"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Rearrangement(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "leftCoordinates",
        "orientation",
        "rightCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "leftCoordinates": reports_6_6_0.Coordinates,
            "rightCoordinates": reports_6_6_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "orientation": reports_6_6_0.Orientation,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import reports as reports_6_6_0

        return {
            "org.gel.models.report.avro.Coordinates": reports_6_6_0.Coordinates,
            "org.gel.models.report.avro.Orientation": reports_6_6_0.Orientation,
            "org.gel.models.report.avro.Coordinates": reports_6_6_0.Coordinates,
            "org.gel.models.report.avro.Rearrangement": reports_6_6_0.Rearrangement,
        }

    __slots__ = [
        "leftCoordinates",
        "orientation",
        "rightCoordinates",
        "leftInsSeq",
        "rightInsSeq",
    ]

    def __init__(
        self,
        leftCoordinates,
        orientation,
        rightCoordinates,
        leftInsSeq=None,
        rightInsSeq=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_6_0.Rearrangement model.

        :param leftCoordinates:
        :type leftCoordinates: Coordinates
        :param orientation:
        :type orientation: Orientation
        :param rightCoordinates:
        :type rightCoordinates: Coordinates
        :param leftInsSeq:
        :type leftInsSeq: None | str
        :param rightInsSeq:
        :type rightInsSeq: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.6.0"
